function [XK1K1,PK1K1,KK1]=fkloop(XKK,PKK,ZK1,F,H,Q,R)
%%%Jess Garca Estbanez%%%
%%%GPS/IMU integration for a Snake robot whith active wheels 2009%%%


% XK1K1: x(k+1|k+1)  Estimated  state for the next step
% PK1K1: P(k+1|k+1) State covariance
% XKK: x(k|k) Vector that contains the datas from the state until the K time
% ZK1:z(k+1) Measurement at k+1
% F,H:System matrix
% Q:State noise covariance v(k)
% R:Measurement noise covariance w(k)
% SYSTEM:
% x(k+1)= F(k) x(k) + v(k+1)
% z(k+1)=H(k+1) x(k+1) + w(k+1)
% KK1 Kalman gain.





% Time update equations 

XK1K=F*XKK;                            
PK1K=F*PKK*F'+Q;                       


KK1=PK1K*H'*inv(H*PK1K*H'+R);

XK1K1=XK1K+KK1*(ZK1-H*XK1K);                                      
PK1K1=PK1K-F*PKK*H'*inv(R+H*PKK*H')*H*PKK*F';                            % Covariance matrix upload 
