function [XK1K1,PK1K1,KK1]=fkloop_extended(XKK,PKK,ZK1,A,H,Q,R)
%%%Jess Garca Estbanez%%%
%%%GPS/IMU integration for a Snake robot whith active wheels 2009%%%

% XK1K1: x(k+1|k+1)  Estimated  state for the next step
% PK1K1: P(k+1|k+1) State covariance
% XKK: x(k|k) Vector that contains the datas from the state until the K time
% ZK1:z(k+1) Measurement at k+1
% F,H:System matrix
% Q:State noise covariance v(k)
% R:Measurement noise covariance w(k)
% SYSTEM:
% x(k+1)= F(k) x(k) + v(k+1)
% z(k+1)=H(k+1) x(k+1) + w(k+1)
% KK1 Kalman gain.





% Time update equations 

XK1K=A*XKK;                            
PK1K=A*PKK*A'+Q;                       

KK1=PK1K*H'*inv(H*PK1K*H'+R);
h=[XK1K(1);XK1K(2);cos(XK1K(7))*XK1K(5)+sin(XK1K(7))*XK1K(6);-sin(XK1K(7))*XK1K(5)+cos(XK1K(7))*XK1K(6);XK1K(8)];
XK1K1=XK1K+KK1*(ZK1-h);                                      



PK1K1=PK1K-A*PKK*H'*inv(R+H*PKK*H')*(H*PKK*A');                               % Actualizacin de la matrix de covarianza con el trmino de innovacin  
