%Error caused by wheel traction lost plots
clc
close all

[a,b,c]=size(positionlinks);
timesim=0:35/(c-1):35;

positionxlink1=eye(1,c);
positionxlink2=eye(1,c);
positionxlink3=eye(1,c);
positionxlink4=eye(1,c);
positionxlink5=eye(1,c);
positionxlink6=eye(1,c);
positionylink1=eye(1,c);
positionylink2=eye(1,c);
positionylink3=eye(1,c);
positionylink4=eye(1,c);
positionylink5=eye(1,c);
positionylink6=eye(1,c);



positionxlink1(:)=positionlinks(1,1,:);
positionxlink2(:)=positionlinks(2,1,:);
positionxlink3(:)=positionlinks(3,1,:);
positionxlink4(:)=positionlinks(4,1,:);
positionxlink5(:)=positionlinks(5,1,:);
positionxlink6(:)=positionlinks(6,1,:);
positionylink1(:)=positionlinks(7,1,:);
positionylink2(:)=positionlinks(8,1,:);
positionylink3(:)=positionlinks(9,1,:);
positionylink4(:)=positionlinks(10,1,:);
positionylink5(:)=positionlinks(11,1,:);
positionylink6(:)=positionlinks(12,1,:);

%Traction
tractionlost1=eye(1,c);
tractionlost2=eye(1,c);
tractionlost3=eye(1,c);
tractionlost4=eye(1,c);
tractionlost5=eye(1,c);
tractionlost6=eye(1,c);

tractionlost1(:)=tractionlost(:,1);
tractionlost2(:)=tractionlost(:,2);
tractionlost3(:)=tractionlost(:,3);
tractionlost4(:)=tractionlost(:,4);
tractionlost5(:)=tractionlost(:,5);
tractionlost6(:)=tractionlost(:,6);


figure('Name','Wheel traction')
hold on

subplot(6,1,1)
plot(timesim,tractionlost1);
grid on
xlabel('Traction');
xlabel('time [sec]');
legend('1th link')
axis([0 35 -0.05 1.1])
subplot(6,1,2)
plot(timesim,tractionlost2);
grid on
xlabel('Traction');
xlabel('time [sec]');
legend('2th link')
axis([0 35 -0.05 1.1])

subplot(6,1,3)
plot(timesim,tractionlost3);
grid on
xlabel('Traction');
xlabel('time [sec]');
legend('3th link')
axis([0 35 -0.05 1.1])

subplot(6,1,4)
plot(timesim,tractionlost4);
grid on
xlabel('Traction');
xlabel('time [sec]');
legend('4th link')
axis([0 35 -0.05 1.1])

subplot(6,1,5)
plot(timesim,tractionlost5);
grid on
xlabel('Traction');
xlabel('time [sec]');
legend('5th link')
axis([0 35 -0.05 1.1])

subplot(6,1,6)
plot(timesim,tractionlost6);
grid on
xlabel('Traction');
xlabel('time [sec]');
legend('6th link')
axis([0 35 -0.05 1.1])



figure('Name','Robot trajectory')
hold on
plot(positionxlink1,positionylink1,positionxlink2,positionylink2,positionxlink3,positionylink3,positionxlink4,positionylink4,positionxlink5,positionylink5,positionxlink6,positionylink6);
grid on
title('Robot trajectory');
xlabel('x position [m]');
ylabel('y position [m]');
legend('1th link','2th link','3th link','4th link','5th link','6th link')
%Error 
errorpositionxlink1=eye(1,c);
errorpositionxlink2=eye(1,c);
errorpositionxlink3=eye(1,c);
errorpositionxlink4=eye(1,c);
errorpositionxlink5=eye(1,c);
errorpositionxlink6=eye(1,c);
errorpositionylink1=eye(1,c);
errorpositionylink2=eye(1,c);
errorpositionylink3=eye(1,c);
errorpositionylink4=eye(1,c);
errorpositionylink5=eye(1,c);
errorpositionylink6=eye(1,c);

errorpositionxlink1(:)=abs(errortrajectory(1,1,:));
errorpositionxlink2(:)=abs(errortrajectory(2,1,:));
errorpositionxlink3(:)=abs(errortrajectory(3,1,:));
errorpositionxlink4(:)=abs(errortrajectory(4,1,:));
errorpositionxlink5(:)=abs(errortrajectory(5,1,:));
errorpositionxlink6(:)=abs(errortrajectory(6,1,:));
errorpositionylink1(:)=abs(errortrajectory(7,1,:));
errorpositionylink2(:)=abs(errortrajectory(8,1,:));
errorpositionylink3(:)=abs(errortrajectory(9,1,:));
errorpositionylink4(:)=abs(errortrajectory(10,1,:));
errorpositionylink5(:)=abs(errortrajectory(11,1,:));
errorpositionylink6(:)=abs(errortrajectory(12,1,:));



figure('Name','Position error')
plot(timesim,errorpositionxlink1,timesim,errorpositionylink1,timesim,errorpositionxlink2,timesim,errorpositionylink2,timesim,errorpositionxlink3,timesim,errorpositionylink3,timesim,errorpositionxlink4,timesim,errorpositionylink4,timesim,errorpositionxlink5,timesim,errorpositionylink5,timesim,errorpositionxlink6,timesim,errorpositionylink6);
grid on
title('Position error');
xlabel('time [s]');
ylabel('error [m]');
legend('x error 1th link','y error 1th link','x error 2th link','y error 2th link','x error 3th link','y error 3th link','x error 4th link','y error 4th link','x error 5th link','y error 5th link','x error 6th link','y error 6th link');

%Ideal estimator

positionlinks_idealx1=eye(1,c);
positionlinks_idealx2=eye(1,c);
positionlinks_idealx3=eye(1,c);
positionlinks_idealx4=eye(1,c);
positionlinks_idealx5=eye(1,c);
positionlinks_idealx6=eye(1,c);
positionlinks_idealy1=eye(1,c);
positionlinks_idealy2=eye(1,c);
positionlinks_idealy3=eye(1,c);
positionlinks_idealy4=eye(1,c);
positionlinks_idealy5=eye(1,c);
positionlinks_idealy6=eye(1,c);



positionlinks_idealx1(:)=positionlinks_ideal(1,1,:);
positionlinks_idealx2(:)=positionlinks_ideal(2,1,:);
positionlinks_idealx3(:)=positionlinks_ideal(3,1,:);
positionlinks_idealx4(:)=positionlinks_ideal(4,1,:);
positionlinks_idealx5(:)=positionlinks_ideal(5,1,:);
positionlinks_idealx6(:)=positionlinks_ideal(6,1,:);
positionlinks_idealy1(:)=positionlinks_ideal(7,1,:);
positionlinks_idealy2(:)=positionlinks_ideal(8,1,:);
positionlinks_idealy3(:)=positionlinks_ideal(9,1,:);
positionlinks_idealy4(:)=positionlinks_ideal(10,1,:);
positionlinks_idealy5(:)=positionlinks_ideal(11,1,:);
positionlinks_idealy6(:)=positionlinks_ideal(12,1,:);

figure('Name','Robot ideal estimator trajectory')
hold on
plot(positionlinks_idealx1,positionlinks_idealy1,positionlinks_idealx2,positionlinks_idealy2,positionlinks_idealx3,positionlinks_idealy3,positionlinks_idealx4,positionlinks_idealy4,positionlinks_idealx5,positionlinks_idealy5,positionlinks_idealx6,positionlinks_idealy6);
grid on
title('Ideal model trajectory');
xlabel('x position [m]');
ylabel('y position [m]');
legend('1th link','2th link','3th link','4th link','5th link','6th link')