/* Include files */

#include "blascompat32.h"
#include "discrete_sfun.h"
#include "c5_discrete.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance.chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance.instanceNumber)
#include "discrete_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define c5_IN_NO_ACTIVE_CHILD          (0)

/* Variable Declarations */

/* Variable Definitions */
static SFc5_discreteInstanceStruct chartInstance;

/* Function Declarations */
static void initialize_c5_discrete(void);
static void initialize_params_c5_discrete(void);
static void enable_c5_discrete(void);
static void disable_c5_discrete(void);
static void c5_update_debugger_state_c5_discrete(void);
static const mxArray *get_sim_state_c5_discrete(void);
static void set_sim_state_c5_discrete(const mxArray *c5_st);
static void finalize_c5_discrete(void);
static void sf_c5_discrete(void);
static void init_script_number_translation(uint32_T c5_machineNumber, uint32_T
  c5_chartNumber);
static void c5_eml_warning(void);
static const mxArray *c5_sf_marshall(void *c5_chartInstance, void *c5_u);
static const mxArray *c5_b_sf_marshall(void *c5_chartInstance, void *c5_u);
static void c5_info_helper(c5_ResolvedFunctionInfo c5_info[24]);
static const mxArray *c5_emlrt_marshallOut(uint8_T c5_u);
static void c5_emlrt_marshallIn(const mxArray *c5_friction, char *c5_name,
  real_T c5_y[6]);
static uint8_T c5_b_emlrt_marshallIn(const mxArray *c5_b_is_active_c5_discrete,
  char *c5_name);
static void init_io_bus_offset(void);
static void init_dsm_address_info(void);

/* Function Definitions */
static void initialize_c5_discrete(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  chartInstance.c5_is_active_c5_discrete = 0U;
}

static void initialize_params_c5_discrete(void)
{
}

static void enable_c5_discrete(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void disable_c5_discrete(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void c5_update_debugger_state_c5_discrete(void)
{
}

static const mxArray *get_sim_state_c5_discrete(void)
{
  const mxArray *c5_st = NULL;
  const mxArray *c5_y = NULL;
  int32_T c5_i0;
  real_T c5_u[6];
  const mxArray *c5_b_y = NULL;
  real_T (*c5_friction)[6];
  c5_friction = (real_T (*)[6])ssGetOutputPortSignal(chartInstance.S, 1);
  c5_st = NULL;
  c5_y = NULL;
  sf_mex_assign(&c5_y, sf_mex_createcellarray(2));
  for (c5_i0 = 0; c5_i0 < 6; c5_i0 = c5_i0 + 1) {
    c5_u[c5_i0] = (*c5_friction)[c5_i0];
  }

  c5_b_y = NULL;
  sf_mex_assign(&c5_b_y, sf_mex_create("y", &c5_u, 0, 0U, 1U, 0U, 1, 6));
  sf_mex_setcell(c5_y, 0, c5_b_y);
  sf_mex_setcell(c5_y, 1, c5_emlrt_marshallOut
                 (chartInstance.c5_is_active_c5_discrete));
  sf_mex_assign(&c5_st, c5_y);
  return c5_st;
}

static void set_sim_state_c5_discrete(const mxArray *c5_st)
{
  const mxArray *c5_u;
  real_T c5_dv0[6];
  int32_T c5_i1;
  real_T (*c5_friction)[6];
  c5_friction = (real_T (*)[6])ssGetOutputPortSignal(chartInstance.S, 1);
  chartInstance.c5_doneDoubleBufferReInit = true;
  c5_u = sf_mex_dup(c5_st);
  c5_emlrt_marshallIn(sf_mex_dup(sf_mex_getcell(c5_u, 0)), "friction", c5_dv0);
  for (c5_i1 = 0; c5_i1 < 6; c5_i1 = c5_i1 + 1) {
    (*c5_friction)[c5_i1] = c5_dv0[c5_i1];
  }

  chartInstance.c5_is_active_c5_discrete = c5_b_emlrt_marshallIn(sf_mex_dup
    (sf_mex_getcell(c5_u, 1)), "is_active_c5_discrete");
  sf_mex_destroy(&c5_u);
  c5_update_debugger_state_c5_discrete();
  sf_mex_destroy(&c5_st);
}

static void finalize_c5_discrete(void)
{
}

static void sf_c5_discrete(void)
{
  int32_T c5_i2;
  int32_T c5_i3;
  int32_T c5_i4;
  uint8_T c5_previousEvent;
  int32_T c5_i5;
  real_T c5_V_tire[6];
  int32_T c5_i6;
  real_T c5_Vlong[6];
  real_T c5_alfa;
  real_T c5_nargout = 1.0;
  real_T c5_nargin = 3.0;
  real_T c5_i;
  real_T c5_m;
  real_T c5_n;
  real_T c5_friction[6];
  int32_T c5_i7;
  real_T c5_b_i;
  real_T c5_a;
  real_T c5_b;
  real_T c5_A;
  real_T c5_x;
  real_T c5_b_x;
  real_T c5_B;
  real_T c5_c_x;
  real_T c5_y;
  real_T c5_d_x;
  real_T c5_b_y;
  real_T c5_e_x;
  real_T c5_c_y;
  real_T c5_d_y;
  int32_T c5_i8;
  real_T *c5_b_alfa;
  real_T (*c5_b_friction)[6];
  real_T (*c5_b_Vlong)[6];
  real_T (*c5_b_V_tire)[6];
  c5_b_V_tire = (real_T (*)[6])ssGetInputPortSignal(chartInstance.S, 0);
  c5_b_alfa = (real_T *)ssGetInputPortSignal(chartInstance.S, 2);
  c5_b_Vlong = (real_T (*)[6])ssGetInputPortSignal(chartInstance.S, 1);
  c5_b_friction = (real_T (*)[6])ssGetOutputPortSignal(chartInstance.S, 1);
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG,3);
  for (c5_i2 = 0; c5_i2 < 6; c5_i2 = c5_i2 + 1) {
    _SFD_DATA_RANGE_CHECK((*c5_b_V_tire)[c5_i2], 0U);
  }

  for (c5_i3 = 0; c5_i3 < 6; c5_i3 = c5_i3 + 1) {
    _SFD_DATA_RANGE_CHECK((*c5_b_friction)[c5_i3], 1U);
  }

  for (c5_i4 = 0; c5_i4 < 6; c5_i4 = c5_i4 + 1) {
    _SFD_DATA_RANGE_CHECK((*c5_b_Vlong)[c5_i4], 2U);
  }

  _SFD_DATA_RANGE_CHECK(*c5_b_alfa, 3U);
  c5_previousEvent = _sfEvent_;
  _sfEvent_ = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG,3);
  for (c5_i5 = 0; c5_i5 < 6; c5_i5 = c5_i5 + 1) {
    c5_V_tire[c5_i5] = (*c5_b_V_tire)[c5_i5];
  }

  for (c5_i6 = 0; c5_i6 < 6; c5_i6 = c5_i6 + 1) {
    c5_Vlong[c5_i6] = (*c5_b_Vlong)[c5_i6];
  }

  c5_alfa = *c5_b_alfa;
  sf_debug_symbol_scope_push(9U, 0U);
  sf_debug_symbol_scope_add("nargout", &c5_nargout, c5_b_sf_marshall);
  sf_debug_symbol_scope_add("nargin", &c5_nargin, c5_b_sf_marshall);
  sf_debug_symbol_scope_add("i", &c5_i, c5_b_sf_marshall);
  sf_debug_symbol_scope_add("m", &c5_m, c5_b_sf_marshall);
  sf_debug_symbol_scope_add("n", &c5_n, c5_b_sf_marshall);
  sf_debug_symbol_scope_add("friction", &c5_friction, c5_sf_marshall);
  sf_debug_symbol_scope_add("alfa", &c5_alfa, c5_b_sf_marshall);
  sf_debug_symbol_scope_add("Vlong", &c5_Vlong, c5_sf_marshall);
  sf_debug_symbol_scope_add("V_tire", &c5_V_tire, c5_sf_marshall);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0,2);
  c5_n = 6.0;
  c5_m = 1.0;
  _SFD_EML_CALL(0,3);
  for (c5_i7 = 0; c5_i7 < 6; c5_i7 = c5_i7 + 1) {
    c5_friction[c5_i7] = 0.0;
  }

  c5_i = 1.0;
  c5_b_i = 1.0;
  while (c5_b_i <= 6.0) {
    c5_i = c5_b_i;
    CV_EML_FOR(0, 0, 1);
    _SFD_EML_CALL(0,5);
    if (CV_EML_COND(0, 0, c5_Vlong[_SFD_EML_ARRAY_BOUNDS_CHECK("Vlong", (int32_T)
          _SFD_INTEGER_CHECK("i", c5_i), 1, 6, 1, 0) - 1] == 0.0)) {
      if (CV_EML_COND(0, 1, c5_V_tire[_SFD_EML_ARRAY_BOUNDS_CHECK("V_tire",
            (int32_T)_SFD_INTEGER_CHECK("i", c5_i), 1, 6, 1, 0) - 1] == 0.0
                      )) {
        CV_EML_MCDC(0, 0, true);
        CV_EML_IF(0, 0, true);
        _SFD_EML_CALL(0,6);
        c5_friction[_SFD_EML_ARRAY_BOUNDS_CHECK("friction", (int32_T)
          _SFD_INTEGER_CHECK("i", c5_i), 1, 6, 1, 0) - 1] = 0.0;
        goto label_1;
      }
    }

    CV_EML_MCDC(0, 0, false);
    CV_EML_IF(0, 0, false);
    _SFD_EML_CALL(0,8);
    c5_a = c5_alfa;
    c5_b = c5_V_tire[_SFD_EML_ARRAY_BOUNDS_CHECK("V_tire", (int32_T)
      _SFD_INTEGER_CHECK("i", c5_i), 1, 6, 1, 0) - 1] - c5_Vlong[
      _SFD_EML_ARRAY_BOUNDS_CHECK("Vlong", (int32_T)_SFD_INTEGER_CHECK("i", c5_i),
      1, 6, 1, 0) - 1];
    c5_A = c5_a * c5_b;
    c5_x = c5_Vlong[_SFD_EML_ARRAY_BOUNDS_CHECK("Vlong", (int32_T)
      _SFD_INTEGER_CHECK("i", c5_i), 1, 6, 1, 0) - 1];
    c5_b_x = c5_x;
    c5_B = muDoubleScalarAbs(c5_b_x);
    c5_c_x = c5_A;
    c5_y = c5_B;
    if (c5_y == 0.0) {
      c5_eml_warning();
    }

    c5_d_x = c5_c_x;
    c5_b_y = c5_y;
    c5_e_x = c5_d_x;
    c5_c_y = c5_b_y;
    c5_d_y = c5_e_x / c5_c_y;
    c5_friction[_SFD_EML_ARRAY_BOUNDS_CHECK("friction", (int32_T)
      _SFD_INTEGER_CHECK("i", c5_i), 1, 6, 1, 0) - 1] = c5_d_y;
   label_1:
    ;
    c5_b_i = c5_b_i + 1.0;
    sf_mex_listen_for_ctrl_c(chartInstance.S);
  }

  CV_EML_FOR(0, 0, 0);
  _SFD_EML_CALL(0,-8);
  sf_debug_symbol_scope_pop();
  for (c5_i8 = 0; c5_i8 < 6; c5_i8 = c5_i8 + 1) {
    (*c5_b_friction)[c5_i8] = c5_friction[c5_i8];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG,3);
  _sfEvent_ = c5_previousEvent;
  sf_debug_check_for_state_inconsistency(_discreteMachineNumber_,
    chartInstance.chartNumber, chartInstance.instanceNumber);
}

static void init_script_number_translation(uint32_T c5_machineNumber, uint32_T
  c5_chartNumber)
{
}

static void c5_eml_warning(void)
{
  int32_T c5_i9;
  static char_T c5_cv0[15] = { 'D', 'i', 'v', 'i', 'd', 'e', ' ', 'b', 'y', ' ',
    'z', 'e', 'r', 'o', '.' };

  char_T c5_u[15];
  const mxArray *c5_y = NULL;
  int32_T c5_i10;
  static char_T c5_cv1[19] = { 'M', 'A', 'T', 'L', 'A', 'B', ':', 'd', 'i', 'v',
    'i', 'd', 'e', 'B', 'y', 'Z', 'e', 'r', 'o' };

  char_T c5_b_u[19];
  const mxArray *c5_b_y = NULL;
  for (c5_i9 = 0; c5_i9 < 15; c5_i9 = c5_i9 + 1) {
    c5_u[c5_i9] = c5_cv0[c5_i9];
  }

  c5_y = NULL;
  sf_mex_assign(&c5_y, sf_mex_create("y", &c5_u, 10, 0U, 1U, 0U, 2, 1, 15));
  for (c5_i10 = 0; c5_i10 < 19; c5_i10 = c5_i10 + 1) {
    c5_b_u[c5_i10] = c5_cv1[c5_i10];
  }

  c5_b_y = NULL;
  sf_mex_assign(&c5_b_y, sf_mex_create("y", &c5_b_u, 10, 0U, 1U, 0U, 2, 1, 19));
  sf_mex_call_debug("warning", 0U, 2U, 14, c5_b_y, 14, c5_y);
}

static const mxArray *c5_sf_marshall(void *c5_chartInstance, void *c5_u)
{
  const mxArray *c5_y = NULL;
  int32_T c5_i11;
  real_T c5_b_u[6];
  const mxArray *c5_b_y = NULL;
  c5_y = NULL;
  for (c5_i11 = 0; c5_i11 < 6; c5_i11 = c5_i11 + 1) {
    c5_b_u[c5_i11] = (*((real_T (*)[6])c5_u))[c5_i11];
  }

  c5_b_y = NULL;
  sf_mex_assign(&c5_b_y, sf_mex_create("y", &c5_b_u, 0, 0U, 1U, 0U, 1, 6));
  sf_mex_assign(&c5_y, c5_b_y);
  return c5_y;
}

static const mxArray *c5_b_sf_marshall(void *c5_chartInstance, void *c5_u)
{
  const mxArray *c5_y = NULL;
  real_T c5_b_u;
  const mxArray *c5_b_y = NULL;
  c5_y = NULL;
  c5_b_u = *((real_T *)c5_u);
  c5_b_y = NULL;
  sf_mex_assign(&c5_b_y, sf_mex_create("y", &c5_b_u, 0, 0U, 0U, 0U, 0));
  sf_mex_assign(&c5_y, c5_b_y);
  return c5_y;
}

const mxArray *sf_c5_discrete_get_eml_resolved_functions_info(void)
{
  const mxArray *c5_nameCaptureInfo = NULL;
  c5_ResolvedFunctionInfo c5_info[24];
  const mxArray *c5_m0 = NULL;
  int32_T c5_i12;
  c5_ResolvedFunctionInfo *c5_r0;
  c5_nameCaptureInfo = NULL;
  c5_info_helper(c5_info);
  sf_mex_assign(&c5_m0, sf_mex_createstruct("nameCaptureInfo", 1, 24));
  for (c5_i12 = 0; c5_i12 < 24; c5_i12 = c5_i12 + 1) {
    c5_r0 = &c5_info[c5_i12];
    sf_mex_addfield(c5_m0, sf_mex_create("nameCaptureInfo", c5_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c5_r0->context)), "context",
                    "nameCaptureInfo", c5_i12);
    sf_mex_addfield(c5_m0, sf_mex_create("nameCaptureInfo", c5_r0->name, 15, 0U,
      0U, 0U, 2, 1, strlen(c5_r0->name)), "name",
                    "nameCaptureInfo", c5_i12);
    sf_mex_addfield(c5_m0, sf_mex_create("nameCaptureInfo", c5_r0->dominantType,
      15, 0U, 0U, 0U, 2, 1, strlen(c5_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c5_i12);
    sf_mex_addfield(c5_m0, sf_mex_create("nameCaptureInfo", c5_r0->resolved, 15,
      0U, 0U, 0U, 2, 1, strlen(c5_r0->resolved)), "resolved"
                    , "nameCaptureInfo", c5_i12);
    sf_mex_addfield(c5_m0, sf_mex_create("nameCaptureInfo", &c5_r0->fileLength,
      7, 0U, 0U, 0U, 0), "fileLength", "nameCaptureInfo",
                    c5_i12);
    sf_mex_addfield(c5_m0, sf_mex_create("nameCaptureInfo", &c5_r0->fileTime1, 7,
      0U, 0U, 0U, 0), "fileTime1", "nameCaptureInfo", c5_i12
                    );
    sf_mex_addfield(c5_m0, sf_mex_create("nameCaptureInfo", &c5_r0->fileTime2, 7,
      0U, 0U, 0U, 0), "fileTime2", "nameCaptureInfo", c5_i12
                    );
  }

  sf_mex_assign(&c5_nameCaptureInfo, c5_m0);
  return c5_nameCaptureInfo;
}

static void c5_info_helper(c5_ResolvedFunctionInfo c5_info[24])
{
  c5_info[0].context = "";
  c5_info[0].name = "size";
  c5_info[0].dominantType = "double";
  c5_info[0].resolved = "[B]size";
  c5_info[0].fileLength = 0U;
  c5_info[0].fileTime1 = 0U;
  c5_info[0].fileTime2 = 0U;
  c5_info[1].context = "";
  c5_info[1].name = "zeros";
  c5_info[1].dominantType = "double";
  c5_info[1].resolved = "[B]zeros";
  c5_info[1].fileLength = 0U;
  c5_info[1].fileTime1 = 0U;
  c5_info[1].fileTime2 = 0U;
  c5_info[2].context = "";
  c5_info[2].name = "eq";
  c5_info[2].dominantType = "double";
  c5_info[2].resolved = "[B]eq";
  c5_info[2].fileLength = 0U;
  c5_info[2].fileTime1 = 0U;
  c5_info[2].fileTime2 = 0U;
  c5_info[3].context = "";
  c5_info[3].name = "minus";
  c5_info[3].dominantType = "double";
  c5_info[3].resolved = "[B]minus";
  c5_info[3].fileLength = 0U;
  c5_info[3].fileTime1 = 0U;
  c5_info[3].fileTime2 = 0U;
  c5_info[4].context = "";
  c5_info[4].name = "mtimes";
  c5_info[4].dominantType = "double";
  c5_info[4].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c5_info[4].fileLength = 2408U;
  c5_info[4].fileTime1 = 1227613402U;
  c5_info[4].fileTime2 = 0U;
  c5_info[5].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c5_info[5].name = "nargin";
  c5_info[5].dominantType = "";
  c5_info[5].resolved = "[B]nargin";
  c5_info[5].fileLength = 0U;
  c5_info[5].fileTime1 = 0U;
  c5_info[5].fileTime2 = 0U;
  c5_info[6].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c5_info[6].name = "gt";
  c5_info[6].dominantType = "double";
  c5_info[6].resolved = "[B]gt";
  c5_info[6].fileLength = 0U;
  c5_info[6].fileTime1 = 0U;
  c5_info[6].fileTime2 = 0U;
  c5_info[7].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c5_info[7].name = "isa";
  c5_info[7].dominantType = "double";
  c5_info[7].resolved = "[B]isa";
  c5_info[7].fileLength = 0U;
  c5_info[7].fileTime1 = 0U;
  c5_info[7].fileTime2 = 0U;
  c5_info[8].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c5_info[8].name = "isinteger";
  c5_info[8].dominantType = "double";
  c5_info[8].resolved = "[B]isinteger";
  c5_info[8].fileLength = 0U;
  c5_info[8].fileTime1 = 0U;
  c5_info[8].fileTime2 = 0U;
  c5_info[9].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c5_info[9].name = "isscalar";
  c5_info[9].dominantType = "double";
  c5_info[9].resolved = "[B]isscalar";
  c5_info[9].fileLength = 0U;
  c5_info[9].fileTime1 = 0U;
  c5_info[9].fileTime2 = 0U;
  c5_info[10].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c5_info[10].name = "strcmp";
  c5_info[10].dominantType = "char";
  c5_info[10].resolved = "[B]strcmp";
  c5_info[10].fileLength = 0U;
  c5_info[10].fileTime1 = 0U;
  c5_info[10].fileTime2 = 0U;
  c5_info[11].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c5_info[11].name = "class";
  c5_info[11].dominantType = "double";
  c5_info[11].resolved = "[B]class";
  c5_info[11].fileLength = 0U;
  c5_info[11].fileTime1 = 0U;
  c5_info[11].fileTime2 = 0U;
  c5_info[12].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c5_info[12].name = "not";
  c5_info[12].dominantType = "logical";
  c5_info[12].resolved = "[B]not";
  c5_info[12].fileLength = 0U;
  c5_info[12].fileTime1 = 0U;
  c5_info[12].fileTime2 = 0U;
  c5_info[13].context = "";
  c5_info[13].name = "abs";
  c5_info[13].dominantType = "double";
  c5_info[13].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c5_info[13].fileLength = 566U;
  c5_info[13].fileTime1 = 1221267134U;
  c5_info[13].fileTime2 = 0U;
  c5_info[14].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c5_info[14].name = "ischar";
  c5_info[14].dominantType = "double";
  c5_info[14].resolved = "[B]ischar";
  c5_info[14].fileLength = 0U;
  c5_info[14].fileTime1 = 0U;
  c5_info[14].fileTime2 = 0U;
  c5_info[15].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c5_info[15].name = "islogical";
  c5_info[15].dominantType = "double";
  c5_info[15].resolved = "[B]islogical";
  c5_info[15].fileLength = 0U;
  c5_info[15].fileTime1 = 0U;
  c5_info[15].fileTime2 = 0U;
  c5_info[16].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c5_info[16].name = "eml_scalar_abs";
  c5_info[16].dominantType = "double";
  c5_info[16].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  c5_info[16].fileLength = 461U;
  c5_info[16].fileTime1 = 1203447960U;
  c5_info[16].fileTime2 = 0U;
  c5_info[17].context =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  c5_info[17].name = "isreal";
  c5_info[17].dominantType = "double";
  c5_info[17].resolved = "[B]isreal";
  c5_info[17].fileLength = 0U;
  c5_info[17].fileTime1 = 0U;
  c5_info[17].fileTime2 = 0U;
  c5_info[18].context = "";
  c5_info[18].name = "mrdivide";
  c5_info[18].dominantType = "double";
  c5_info[18].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.m";
  c5_info[18].fileLength = 771U;
  c5_info[18].fileTime1 = 1219752936U;
  c5_info[18].fileTime2 = 0U;
  c5_info[19].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.m";
  c5_info[19].name = "ge";
  c5_info[19].dominantType = "double";
  c5_info[19].resolved = "[B]ge";
  c5_info[19].fileLength = 0U;
  c5_info[19].fileTime1 = 0U;
  c5_info[19].fileTime2 = 0U;
  c5_info[20].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.m";
  c5_info[20].name = "rdivide";
  c5_info[20].dominantType = "double";
  c5_info[20].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c5_info[20].fileLength = 620U;
  c5_info[20].fileTime1 = 1213926766U;
  c5_info[20].fileTime2 = 0U;
  c5_info[21].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c5_info[21].name = "isempty";
  c5_info[21].dominantType = "double";
  c5_info[21].resolved = "[B]isempty";
  c5_info[21].fileLength = 0U;
  c5_info[21].fileTime1 = 0U;
  c5_info[21].fileTime2 = 0U;
  c5_info[22].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c5_info[22].name = "eml_warning";
  c5_info[22].dominantType = "char";
  c5_info[22].resolved =
    "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_warning.m";
  c5_info[22].fileLength = 274U;
  c5_info[22].fileTime1 = 1227613396U;
  c5_info[22].fileTime2 = 0U;
  c5_info[23].context = "[I]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c5_info[23].name = "eml_div";
  c5_info[23].dominantType = "double";
  c5_info[23].resolved = "[I]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  c5_info[23].fileLength = 4269U;
  c5_info[23].fileTime1 = 1227613386U;
  c5_info[23].fileTime2 = 0U;
}

static const mxArray *c5_emlrt_marshallOut(uint8_T c5_u)
{
  const mxArray *c5_y = NULL;
  c5_y = NULL;
  sf_mex_assign(&c5_y, sf_mex_create("y", &c5_u, 3, 0U, 0U, 0U, 0));
  return c5_y;
}

static void c5_emlrt_marshallIn(const mxArray *c5_friction, char *c5_name,
  real_T c5_y[6])
{
  real_T c5_dv1[6];
  int32_T c5_i13;
  sf_mex_import(c5_name, sf_mex_dup(c5_friction), &c5_dv1, 1, 0, 0U, 1, 0U, 1, 6);
  for (c5_i13 = 0; c5_i13 < 6; c5_i13 = c5_i13 + 1) {
    c5_y[c5_i13] = c5_dv1[c5_i13];
  }

  sf_mex_destroy(&c5_friction);
}

static uint8_T c5_b_emlrt_marshallIn(const mxArray *c5_b_is_active_c5_discrete,
  char *c5_name)
{
  uint8_T c5_y;
  uint8_T c5_u0;
  sf_mex_import(c5_name, sf_mex_dup(c5_b_is_active_c5_discrete), &c5_u0, 1, 3,
                0U, 0, 0U, 0);
  c5_y = c5_u0;
  sf_mex_destroy(&c5_b_is_active_c5_discrete);
  return c5_y;
}

static void init_io_bus_offset(void)
{
}

static void init_dsm_address_info(void)
{
}

/* SFunction Glue Code */
void sf_c5_discrete_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(2482135578U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(875478923U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(3853852945U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(2724709318U);
}

mxArray *sf_c5_discrete_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,4,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(4025449524U);
    pr[1] = (double)(1168463125U);
    pr[2] = (double)(2775582341U);
    pr[3] = (double)(2543396916U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,3,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  return(mxAutoinheritanceInfo);
}

static mxArray *sf_get_sim_state_info_c5_discrete(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[5],T\"friction\",},{M[8],M[0],T\"is_active_c5_discrete\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c5_discrete_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_discreteMachineNumber_,
          5,
          1,
          1,
          4,
          0,
          0,
          0,
          0,
          0,
          &(chartInstance.chartNumber),
          &(chartInstance.instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_discreteMachineNumber_,
            chartInstance.chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_discreteMachineNumber_,
            chartInstance.chartNumber,1);
          sf_debug_set_chart_event_thresholds(_discreteMachineNumber_,
            chartInstance.chartNumber,
            0,
            0,
            0);

          {
            unsigned int dimVector[1];
            dimVector[0]= 6;
            _SFD_SET_DATA_PROPS(0,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"V_tire",0,c5_sf_marshall);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 6;
            _SFD_SET_DATA_PROPS(1,2,0,1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"friction",0,NULL);
          }

          {
            unsigned int dimVector[1];
            dimVector[0]= 6;
            _SFD_SET_DATA_PROPS(2,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"Vlong",0,NULL);
          }

          _SFD_SET_DATA_PROPS(3,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"alfa",0,
                              c5_b_sf_marshall);
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of EML Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,0,1,0,2,1);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,251);
        _SFD_CV_INIT_EML_IF(0,0,108,144,170,247);
        _SFD_CV_INIT_EML_FOR(0,0,92,104,251);

        {
          static int condStart[] = { 112, 129 };

          static int condEnd[] = { 125, 143 };

          static int pfixExpr[] = { 0, 1, -3 };

          _SFD_CV_INIT_EML_MCDC(0,0,111,144,2,0,&(condStart[0]),&(condEnd[0]),3,
                                &(pfixExpr[0]));
        }

        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          real_T (*c5_V_tire)[6];
          real_T (*c5_friction)[6];
          real_T (*c5_Vlong)[6];
          real_T *c5_alfa;
          c5_V_tire = (real_T (*)[6])ssGetInputPortSignal(chartInstance.S, 0);
          c5_alfa = (real_T *)ssGetInputPortSignal(chartInstance.S, 2);
          c5_Vlong = (real_T (*)[6])ssGetInputPortSignal(chartInstance.S, 1);
          c5_friction = (real_T (*)[6])ssGetOutputPortSignal(chartInstance.S, 1);
          _SFD_SET_DATA_VALUE_PTR(0U, c5_V_tire);
          _SFD_SET_DATA_VALUE_PTR(1U, c5_friction);
          _SFD_SET_DATA_VALUE_PTR(2U, c5_Vlong);
          _SFD_SET_DATA_VALUE_PTR(3U, c5_alfa);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_discreteMachineNumber_,
        chartInstance.chartNumber,chartInstance.instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c5_discrete(void *chartInstanceVar)
{
  chart_debug_initialization(chartInstance.S,0);
  initialize_params_c5_discrete();
  initialize_c5_discrete();
}

static void sf_opaque_enable_c5_discrete(void *chartInstanceVar)
{
  enable_c5_discrete();
}

static void sf_opaque_disable_c5_discrete(void *chartInstanceVar)
{
  disable_c5_discrete();
}

static void sf_opaque_gateway_c5_discrete(void *chartInstanceVar)
{
  sf_c5_discrete();
}

static mxArray* sf_opaque_get_sim_state_c5_discrete(void *chartInstanceVar)
{
  mxArray *st = (mxArray *) get_sim_state_c5_discrete();
  return st;
}

static void sf_opaque_set_sim_state_c5_discrete(void *chartInstanceVar, const
  mxArray *st)
{
  set_sim_state_c5_discrete(sf_mex_dup(st));
}

static void sf_opaque_terminate_c5_discrete(void *chartInstanceVar)
{
  if (sim_mode_is_rtw_gen(chartInstance.S) || sim_mode_is_external
      (chartInstance.S)) {
    sf_clear_rtw_identifier(chartInstance.S);
  }

  finalize_c5_discrete();
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c5_discrete(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c5_discrete();
  }
}

static void mdlSetWorkWidths_c5_discrete(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("discrete","discrete",5);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop("discrete","discrete",5,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("discrete","discrete",5,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"discrete","discrete",5,3);
      sf_mark_chart_reusable_outputs(S,"discrete","discrete",5,1);
    }

    sf_set_rtw_dwork_info(S,"discrete","discrete",5);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(3166042393U));
  ssSetChecksum1(S,(2972125918U));
  ssSetChecksum2(S,(1236088220U));
  ssSetChecksum3(S,(208975008U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c5_discrete(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "discrete", "discrete",5);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c5_discrete(SimStruct *S)
{
  chartInstance.chartInfo.chartInstance = NULL;
  chartInstance.chartInfo.isEMLChart = 1;
  chartInstance.chartInfo.chartInitialized = 0;
  chartInstance.chartInfo.sFunctionGateway = sf_opaque_gateway_c5_discrete;
  chartInstance.chartInfo.initializeChart = sf_opaque_initialize_c5_discrete;
  chartInstance.chartInfo.terminateChart = sf_opaque_terminate_c5_discrete;
  chartInstance.chartInfo.enableChart = sf_opaque_enable_c5_discrete;
  chartInstance.chartInfo.disableChart = sf_opaque_disable_c5_discrete;
  chartInstance.chartInfo.getSimState = sf_opaque_get_sim_state_c5_discrete;
  chartInstance.chartInfo.setSimState = sf_opaque_set_sim_state_c5_discrete;
  chartInstance.chartInfo.getSimStateInfo = sf_get_sim_state_info_c5_discrete;
  chartInstance.chartInfo.zeroCrossings = NULL;
  chartInstance.chartInfo.outputs = NULL;
  chartInstance.chartInfo.derivatives = NULL;
  chartInstance.chartInfo.mdlRTW = mdlRTW_c5_discrete;
  chartInstance.chartInfo.mdlStart = mdlStart_c5_discrete;
  chartInstance.chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c5_discrete;
  chartInstance.chartInfo.extModeExec = NULL;
  chartInstance.chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.storeCurrentConfiguration = NULL;
  chartInstance.S = S;
  ssSetUserData(S,(void *)(&(chartInstance.chartInfo)));/* register the chart instance with simstruct */
  if (!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info();
  }

  chart_debug_initialization(S,1);
}

void c5_discrete_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c5_discrete(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c5_discrete(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c5_discrete(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c5_discrete_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
